
#include "audio.h"

CAudioSystem *CAudioSystem::Instance = 0;

void CAudioSystem::Init()
{
	BASS_Init(-1, 44100, BASS_DEVICE_MONO | BASS_DEVICE_3D | 
              BASS_MUSIC_3D | BASS_DEVICE_NOSYNC | BASS_DEVICE_LEAVEVOL |
              BASS_DEVICE_NOTHREAD, 0);

	BASS_Start();
}

void CAudioSystem::Update()
{
	BASS_Update();
}

void CAudioSystem::Kill()
{
	BASS_Stop();
	BASS_Free();
	/*if(Instance)
		delete Instance;
	Instance = 0;*/ 
}

HSTREAM CAudioSystem::LoadMP3(char *FileName)
{
	HSTREAM temp =  BASS_StreamCreateFile(false, FileName, 0, 0, 
                                 BASS_SAMPLE_3D | BASS_SAMPLE_MONO);
	BASS_ChannelStop(temp);

	return temp;
}
		
void CAudioSystem::PlayMP3(HSTREAM Stream, bool Loop)
{
	BASS_StreamPlay(Stream, false, (Loop) ? BASS_SAMPLE_LOOP : 0);
}

void CAudioSystem::UnloadMP3(HSTREAM Stream)
{
	BASS_StreamFree(Stream);
}

void CAudioSystem::StopAll()
{
	BASS_Stop();
}

void CAudioSystem::SetGlobalVolume(int Percent)
{
	BASS_SetVolume(Percent);
}

int CAudioSystem::GetGlobalVolume()
{
	return BASS_GetVolume();
}		

void CAudioSystem::SetChannelVolume(DWORD Handle, int Percent)
{
	BASS_ChannelSetAttributes(Handle, -1, Percent, -1);
}

//----------------- insert 3D function defs here. ------------------

BASS_3DVECTOR CAudioSystem::BASS_Vector(CVector Source)
{
	 BASS_3DVECTOR Dest = {Source.x, Source.y, Source.z};
	 return Dest;
}
