
#include "bitmap.h"

unsigned char *Load8BitBMP(char *FileName, int &height, int &width)
// huge thanks to 'Ready4Dis' for this function //
{ 
	FILE *in = fopen(FileName,"rb"); 
	unsigned char *Image_Data; 
	unsigned char Index; 
	unsigned long Offset; 
	unsigned long TotalSize; 
	unsigned char Palette[256][3]; //Palette information! 
	int x, y; 
	
	if (!in) //File exists?  
		return 0; 
	
	if (getc(in)!='B'||getc(in)!='M') //Valid bitmap header? 
	{  
		fclose(in);  
		return 0; 
	} 
	
	fseek(in,18,0); //begining of width! 
	width = getw(in); fseek(in,22,0); //begining of height! 
	height = getw(in); fseek(in,28,0); 
	
	if (getc(in)!=8) //Is it really 8-bits? 
	{
		fclose(in);  
		return 0; 
	} 
	
	TotalSize = width*height; fseek(in,54,0); //start of palette info!          
	for (x=0;x!=256;++x) 
	{  
		Palette[x][2] = getc(in); //Blue 
		Palette[x][1] = getc(in); //Green  
		Palette[x][0] = getc(in); //Red  
		getc(in); //Intensity (ignore this!) 
	}
		
	Image_Data = new unsigned char[TotalSize*3]; 
	
	if (!Image_Data) //Got memory right? 
	{  
		fclose(in);
		return 0; 
	} 
	
	for (y=0;y<height;y++) //Bitmaps are upside down! 
	{  
		Offset=y*width*3;  
		
		for (x=0;x!=width;++x)  
			{   
			Index=getc(in); //Get our Palette index!  
			Image_Data[Offset++]=Palette[Index][0]; //Red 
			Image_Data[Offset++]=Palette[Index][1]; //Green 
			Image_Data[Offset++]=Palette[Index][2]; //Blue
		}
	} 
	return Image_Data;
}

/*unsigned char *Load8BitBMP(char *FileName, int &height, int &width)
// huge thanks to 'Ready4Dis' for help with this function //
{ 
	ifstream File(FileName, ios::nocreate);

	unsigned char *ImageData; 
	unsigned char *Temp;	
	unsigned char *Palette;
	unsigned long TotalSize; 
	int Colors;
	
	BITMAPFILEHEADER FileHeader;	
	BITMAPINFOHEADER InfoHeader;	
	
	File.read((char *)&FileHeader, sizeof(BITMAPFILEHEADER));
	
	if(FileHeader.bfType != 0x4D42)
		return 0;	
	
	File.read((char *)&InfoHeader, sizeof(BITMAPINFOHEADER));	
	
	Colors = (InfoHeader.biClrUsed == 0) ? 255 : InfoHeader.biClrUsed;
	
	width = InfoHeader.biWidth;	
	height = InfoHeader.biHeight;	
	TotalSize = width*height; 
	
	Temp = new unsigned char[TotalSize];
	ImageData = new unsigned char[TotalSize*3]; 
	Palette = new unsigned char[256*4];

	File.read((char *)Palette, Colors*4);
	File.read((char *)Temp, TotalSize);
	
	for(int i = 0; i < TotalSize; i++)
	{   
		ImageData[i*3]  =Palette[Temp[i]*4+2];
		ImageData[i*3+1]=Palette[Temp[i]*4+1];
		ImageData[i*3+2]=Palette[Temp[i]*4];
	}
	
	delete [] Temp;

	return ImageData;
}*/

/*unsigned char *LoadBMP(char *file_name, int &height, int &width)
{
	ifstream File(file_name, ios::binary);
	BITMAPFILEHEADER FileHeader;
	BITMAPINFOHEADER InfoHeader;

	unsigned char *Palette;
	unsigned char *ImageData;
	unsigned char *Temp;

	File.read((char *)&FileHeader, sizeof(BITMAPFILEHEADER));

	if(FileHeader.bfType != 0x4D42)
		return 0;

	File.read((char *)&InfoHeader, sizeof(BITMAPINFOHEADER));

	if(InfoHeader.biClrUsed == 0)
		InfoHeader.biClrUsed = 256;

	width = InfoHeader.biWidth;
	height = InfoHeader.biHeight;

	Temp = new unsigned char[InfoHeader.biWidth*InfoHeader.biHeight];
	Palette = new unsigned char[InfoHeader.biClrUsed*4];

	File.read((char *)Palette, sizeof(InfoHeader.biClrUsed*4));

	File.read((char *)Temp, InfoHeader.biWidth*InfoHeader.biHeight);

	ImageData = new unsigned char[InfoHeader.biWidth*InfoHeader.biHeight*3];

	for(int i = 0; i < InfoHeader.biWidth*InfoHeader.biHeight; i++)
	{
		ImageData[i*3] = Palette[Temp[i]];
		ImageData[i*3+1] = Palette[Temp[i+1]];
		ImageData[i*3+2] = Palette[Temp[i+2]];
	}

	File.close();

	delete [] Temp;
	delete [] Palette;

	return ImageData;
}*/


unsigned char *LoadBitmap(LPSTR filename, int &height, int &width)
{
	BITMAPFILEHEADER FileHeader;
	BITMAPINFOHEADER InfoHeader;

	unsigned char *ImageData;
	unsigned char Temp;

	ifstream File(filename, ios::binary);

	if(File.fail())
		return 0;   // presumably the file doesn't exist...

	File.read((char *)&FileHeader, sizeof(BITMAPFILEHEADER));

	if(FileHeader.bfType != 0x4D42)
		return 0;   // dirty traitor!  you're not really a BMP!

	File.read((char *)&InfoHeader, sizeof(BITMAPINFOHEADER));

	ImageData = new unsigned char[InfoHeader.biSizeImage];

	if(!ImageData)
		return 0;   // malloc failed - this shouldn't happen

	File.seekg(FileHeader.bfOffBits);

	switch(InfoHeader.biBitCount)
	{
		case 24:
			File.read((char *)ImageData, InfoHeader.biSizeImage);
			break;

		case 8:
			File.close();
			delete [] ImageData;
			return Load8BitBMP(filename, height, width);
			break;

		default: 
			return 0; // can't handle this...
			break; 
	}

	if(!ImageData)
		return 0;    // couldn't read data - this shouldn't happen

	for(unsigned int i = 0; i < InfoHeader.biSizeImage; i+=3)
	{
		Temp = ImageData[i];
		ImageData[i] = ImageData[i+2];
		ImageData[i+2] = Temp;
	}
	
	height = absval(InfoHeader.biHeight);
	width = absval(InfoHeader.biWidth); 

	return ImageData;
}