
//-------------- file start ----------------
// * caffeine engine  - default.h
// * copyright 2002-3 zealouselixir software
// * created march 16, 2002
// * default header file
// * this file includes all files required
//   by operations and types in the engine.
//   if you wish to add a header to be 
//   useable by all methods and objects,
//   include it here.
//------------------------------------------

//------------- directives -----------------

#ifndef CAFFEINE_DEFAULT_H
#define CAFFEINE_DEFAULT_H

//------- eliminate default bloats  --------

#define WIN32_LEAN_AND_MEAN
#define WIN32_EXTRA_LEAN
#define VC_EXTRALEAN

//-- eliminate specific windows.h bloats ---

#define NOGDICAPMASKS     //CC_*, LC_*, PC_*, CP_*, TC_*, RC_
#define NOMENUS           //MF_*
#define NOSYSCOMMANDS     //SC_*
#define NORASTEROPS       //Binary and Tertiary raster ops
#define OEMRESOURCE       //OEM Resource values
#define NOATOM            //Atom Manager routines
#define NOCLIPBOARD       //Clipboard routines
#define NOCOLOR           //Screen colors
//#define NOCTLMGR          //Control and Dialog routines
#define NODRAWTEXT        //DrawText() and DT_*
#define NOKERNEL          //All KERNEL defines and routines
#define NONLS             //All NLS defines and routines
#define NOMEMMGR          //GMEM_*, LMEM_*, GHND, LHND, associated routines
#define NOMETAFILE        //typedef METAFILEPICT
#define NOMINMAX          //Macros min(a,b) and max(a,b)
#define NOOPENFILE        //OpenFile(), OemToAnsi, AnsiToOem, and OF_*
#define NOSCROLL          //SB_* and scrolling routines
#define NOSERVICE         //All Service Controller routines, SERVICE_ equates, etc.
#define NOSOUND           //Sound driver routines
#define NOTEXTMETRIC      //typedef TEXTMETRIC and associated routines
#define NOWH              //SetWindowsHook and WH_*
#define NOWINOFFSETS      //GWL_*, GCL_*, associated routines
#define NOCOMM            //COMM driver routines
#define NOKANJI           //Kanji support stuff.
#define NOHELP            //Help engine interface.
#define NOPROFILER        //Profiler interface.
#define NODEFERWINDOWPOS  //DeferWindowPos routines
#define NOMCX             //Modem Configuration Extensions

//----------- optimizations ----------------

/*
         OPTIMIZATION STATISTICS
		 -----------------------
   -NONE:             76.0 KB
   -w/o ALLIGN        72.0 KB ( 8.0 KB)
   -w/o GSY:          67.5 KB ( 1.5 KB)
   -w/o MERGE:        66.5 KB ( 0.5 KB)
   -ALL:              66.0 KB (10.0 KB)
*/

#pragma optimize("gsy", on)
#pragma comment(linker, "/merge:.text=.data")
#pragma comment(linker, "/FILEALIGN:0x200")

//--------- global header files ------------

#include <windows.h>

#include <gl/gl.h>

#include <fstream.h>
#include <stdarg.h>
#include <stdlib.h>
#include <stdio.h>

#include "bass.h"

//------------- corrections ---------------

/*#ifdef PlaySound // undo a few macros for Windowz
#undef PlaySound 
#endif

#ifdef LoadBitmap
#undef LoadBitmap 
#endif*/

#ifndef VK_1     // define some non-portable VK's
#define VK_1 48
#define VK_2 49
#define VK_3 50
#define VK_4 51
#define VK_5 52
#define VK_6 53
#define VK_7 54
#define VK_8 55
#define VK_9 56
#define VK_0 57
#endif

#ifndef VK_A
#define VK_A 65
#define VK_B 66
#define VK_C 67
#define VK_D 68
#define VK_E 69
#define VK_F 70
#define VK_G 71
#define VK_H 72
#define VK_I 73
#define VK_J 74
#define VK_K 75
#define VK_L 76
#define VK_M 77
#define VK_N 78
#define VK_O 79
#define VK_P 80
#define VK_Q 81
#define VK_R 82
#define VK_S 83
#define VK_T 84
#define VK_U 85
#define VK_V 86
#define VK_W 87
#define VK_X 88
#define VK_Y 89
#define VK_Z 90
#endif

inline void Popup(char *in_string, ...)
{
	char out_string[256];
	va_list params;
	va_start(params, in_string);
	vsprintf(out_string, in_string, params);
	va_end(params);

	MessageBox(0,out_string, "info.", MB_OK);
}

inline void PopupError()
{
	char ErrorString[255];
	char CodeString[10];
	long ErrorCode = GetLastError();
	FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, 0, ErrorCode, 
		          0, ErrorString, 255, 0);
	sprintf(CodeString, " (#%i)", ErrorCode);
	strcat(ErrorString, CodeString);
	MessageBox(0,ErrorString, "GetLastError() reports...", MB_OK);
}

#include "glcrap.h"

//------------ library files ---------------


#pragma comment(lib, "kernel32.lib")
// getting linker errors on pre-Win2k?  uncomment this.
//#pragma comment(lib, "user32.lib")
#pragma comment(lib, "gdi32.lib")
#pragma comment(lib, "opengl32.lib")
#pragma comment(lib, "bass.lib")

//------------- directives -----------------

#endif  // __CAFFEINE_WINMAIN_H

//-------------- file end ------------------
