
#ifndef CAFFEINE_ENEMY
#define CAFFEINE_ENEMY

#include "default.h"
#include "node.h"
#include "object.h"
#include "player.h"
#include "terrain.h"
#include "md2.h"
//#include "bala.h"

enum AIState
{
	AI_IDLE_TRANS,
	AI_IDLE,
	AI_INTERESTED_TRANS,
	AI_INTERESTED,
	AI_DYING_TRANS,
	AI_DYING,
	AI_DEAD
};

class CEnemy : public CObject
{
	public:
		CEnemy();
		CEnemy(CVector, int);
		CEnemy(CVector, CVector, int);
		~CEnemy();

	public:
		void Damage(int DamagePoints);

		void SetPos(CVector NewPos);
		void SetRot(CVector NewOri);
		void SetVel(CVector NewVel);

		void SetRep(CMD2Model *NewRep);
		void SetAnimation(const Animation &NewAnim);

		void SetTerrain(CTerrain *NewTer);

		bool Alive()
		{	return (HitPoints > 0); };

	protected:
		virtual void OnDraw(CCamera *camera);
		virtual void OnAnimate(float Time);
		virtual void OnAI();
		virtual void OnCollision(CObject *Collider);

	private:
		int HitPoints;

		CMD2Model *Rep;  // modelar representation
		Animation CurrentAnim;
		int CurrentFrame;
		int NextFrame;
		float Percent;

		AIState State;

		CTerrain *Terrain;

		RTT Type;

		CVector PlayerLoc;
		CVector PlayerVec;
		float PlayerDist;
		float PlayerDir; 

		bool Collided;
};

#endif