
//-------------- file start ----------------
// * caffeine engine - input.cpp
// * copyright 2002-3 zealouselixir software
// * created march 16, 2002
// * input system implementation
// * this file contains all input
// * interface function declarations.
//------------------------------------------

#include "input.h"

CInputSystem *CInputSystem::Instance = 0;

bool CInputSystem::MouseButtonDown(int ButtonNum)
{
	switch(ButtonNum)
	{
		case(MOUSE_LEFT):
			return (GetAsyncKeyState(VK_LBUTTON) & 0x8000 ? true : false);
		case(MOUSE_RIGHT):
			return (GetAsyncKeyState(VK_RBUTTON) & 0x8000 ? true : false);
		case(MOUSE_MIDDLE):
			return (GetAsyncKeyState(VK_MBUTTON) & 0x8000  ? true : false);
		default:
			break;
	}

	return false;  
}

void CInputSystem::GetMouseMovement(int &X, int &Y)
{
	//zero these out in case our mouse doesn't work
    X = 0; Y = 0;

	static RECT WindowSize;
	static POINT CurPoint;
	GetWindowRect(CEngine::Get()->GetHandle(), &WindowSize);
	POINT CenterPoint = { WindowSize.right/2, WindowSize.bottom/2 };

	GetCursorPos(&CurPoint);
	X = CenterPoint.x - CurPoint.x;
	Y = CenterPoint.y - CurPoint.y;
	SetCursorPos(CenterPoint.x, CenterPoint.y);
}

bool CInputSystem::KeyDown(int KeyCode)
{
	return (GetAsyncKeyState(KeyCode) & 0x8000) ? true : false;
}
