
//-------------- file start ----------------
// * caffeine engine - input.h
// * copyright 2002-3 zealouselixir software
// * created march 16, 2002
// * input system declaration
// * this file contains all input
// * interface function declataions.
//------------------------------------------

#ifndef CAFFEINE_INPUT
#define CAFFEINE_INPUT

#include "default.h"
#include "constants.h"
#include "engine.h"

class CInputSystem  
{
	protected:
		CInputSystem() {};

		~CInputSystem()
		{
			if(Instance)
				delete Instance;
		};
	public:
		static CInputSystem *Get()
		{
			if(!Instance)
				Instance = new CInputSystem;
			return Instance;
		};

        bool KeyDown(int);
        
        bool MouseButtonDown(int);
        void GetMouseMovement(int &, int &);

    private:
		static CInputSystem *Instance;

		InputType Type;

		float MouseSensitivity;
		POINT LastPoint;  // last mouse location
};

#endif

//----------------- file end ----------------