
#include "object.h"

CObject::CObject()
: Location(0,0,0), Acceleration(0,0,0), Velocity(0,0,0)
{
	Type = TypeList[OBJECT_GENERIC];
}

CObject::~CObject()
{
}

void CObject::Draw(CCamera *camera)
{
	glPushMatrix();  // watch for stack overflow upon 
	                 // recursion 30+ levels deep. One
	                 // fix for this is to convert CNode
	                 // into a TREE node class.
	OnDraw(camera);

	if(Next)
		((CObject*)Next)->Draw(camera);

	glPopMatrix();
}

void CObject::OnDraw(CCamera *camera)
{
}

void CObject::Animate(float Time)
{
	OnAnimate(Time);

	if(Next)
		((CObject*)Next)->Animate(Time);
}

void CObject::OnAnimate(float Time)
{
	//Location += Velocity;
}

void CObject::Collide(CObject *Object)
{
	OnCollision(Object);

	if(Next)
		((CObject*)Next)->Collide(Object);
}


void CObject::OnCollision(CObject *Object)
{
}

void CObject::AI()
{
	OnAI();

	if(Next)
		((CObject*)Next)->AI();
}


void CObject::OnAI()
{
}

