
#include "sky.h"

CSky::CSky()
{
	Color[0] = 0.0f;
	Color[1] = 0.7f;
	Color[2] = 1.0f;
	Size = CVector(64*30, 1200.0f, 64.0f*30.0f);
}

CSky::CSky(char *TextureFile)
{
	Color[0] = 0.0f;
	Color[1] = 0.7f;
	Color[2] = 1.0f;
	Size = CVector(64*30, 1200.0f, 64.0f*30.0f);
	Load(TextureFile);
}

bool CSky::Load(char *TextureFile)
{
	Texture.Load(TextureFile);

	return true;
}

void CSky::Draw(CCamera *camera)
{
	static float width = Size.x;
	static float height = Size.y;
	static float length = Size.z;

	float x = camera->GetPos(X_AXIS)-width*0.5f;
	float y = 0.0f;
	float z = camera->GetPos(Z_AXIS)-length*0.5f;

	static float nothin = 0.0f;

	Texture.Use();
	glColor3fv(Color);

	glBegin(GL_QUADS);		
	    //back
		glTexCoord2f(0.0f, 1.0f); glVertex3f(x + width,	y + height, z - length);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(x - width, y + height, z - length); 
		glTexCoord2f(1.0f, 0.0f); glVertex3f(x - width, y + nothin, z - length);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(x + width,	y + nothin, z - length);

		//front
		glTexCoord2f(0.0f, 1.0f); glVertex3f(x - width, y + height, z + length);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(x + width,	y + height,	z + length);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(x + width,	y + nothin, z + length);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(x - width, y + nothin, z + length); 

		//top
		glTexCoord2f(0.0f, 1.0f); glVertex3f(x - width, y + height, z - length);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(x + width, y + height,	z - length);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(x + width ,y + height,	z + length);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(x - width, y + height, z + length); 

		//right
		glTexCoord2f(0.0f, 1.0f); glVertex3f(x - width,	y + height, z - length);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(x - width,	y + height,	z + length);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(x - width,	y + nothin,	z + length);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(x - width,	y + nothin, z - length); 

		//left
		glTexCoord2f(0.0f, 1.0f); glVertex3f(x + width, y + height,	z + length);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(x + width, y + height,	z - length);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(x + width, y + nothin,	z - length);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(x + width, y + nothin,	z + length); 
	glEnd();
}
