
#ifndef CAFFEINE_TIMER
#define CAFFEINE_TIMER

#include "default.h"

class CTimer
{
	public:
		static CTimer *Get()
		{
			if(!Instance)
				Instance = new CTimer;
			return Instance;
		}

		void Update()
		{
			FramesPerSec = float(Frequency.QuadPart / double(FrameEnd.QuadPart - FrameStart.QuadPart));

			FrameStart = FrameEnd;
			QueryPerformanceCounter(&FrameEnd);
		}

		float FPS()
		{
			return FramesPerSec;
		}

		float GetLastFrameTime()
		{
			//if(FramesPerSec == 0)   // can't justify this protection yet...
			//	return 1/EPSILON;     // uncomment if GetLastFrameTime crashes
			return 1/FramesPerSec;
		}

		float GetRunningTime()
		{
			return (FrameEnd.QuadPart-StartTick.QuadPart)/(float)Frequency.QuadPart;
		}

	protected:
		CTimer()
		{
			QueryPerformanceFrequency(&Frequency);
			QueryPerformanceCounter(&StartTick);
		}

	private:
		LARGE_INTEGER StartTick;
		LARGE_INTEGER Frequency;
		LARGE_INTEGER FrameStart;
		LARGE_INTEGER FrameEnd;
		float FramesPerSec;
		static CTimer *Instance;
};

#endif

