
#ifndef CAFFEINE_WORLD
#define CAFFEINE_WORLD

#include "default.h"
#include "vector.h"
#include "node.h"
#include "object.h"
#include "terrain.h"

class CWorld
{
	public:
		static CWorld *Get()
		{
			if(!Instance)
				Instance = new CWorld;
			return Instance;
		}

		void Add(CObject *NewItem);

		void Draw(CCamera *camera);
		void Animate();
		//void AI();
		//void Collide();

	protected:
		CWorld()
		{
			ObjectList = new CObject;
		}

		~CWorld()
		{
			delete ObjectList;
		}

	private:
		static CWorld *Instance;
		CObject *ObjectList;
		CTerrain *Terrain;
		//CSkybox *Skybox;
};

#endif
